#ifndef _BOX_H

#define _BOX_H

#include "vector3d.h"

/**
       ---------
       |0     1|
       |       |
       |2     3|
       ---------
          TOP
  
       ---------
       |4     5|
       |       |
       |6     7|
       ---------
        BOTTOM
*/

class Box
                        /** Box in 3D space. */
{
        private:
                Vector3D vertices[8];
        public:
                Box();
                Box(double x1, double y1, double z1, double x2, double y2, double z2);
                Vector3D *GetVertices();
                void Print();
};

#endif
