#include "bttnode.h"
#include "bttpool.h"
#include <iostream>

void BTTNode::Merge(BTTPool *pool)
{
        LeftNeighbour=LeftChild->BaseNeighbour;
        if (LeftNeighbour->LeftNeighbour==LeftChild)
                LeftNeighbour->LeftNeighbour=this;
        else
                if (LeftNeighbour->RightNeighbour==LeftChild)
                        LeftNeighbour->RightNeighbour=this;
                else
                {
                        LeftNeighbour->BaseNeighbour=this;
                }
        pool->FreeNode(LeftChild);
        LeftChild=NULL;

        RightNeighbour=RightChild->BaseNeighbour;
        if (RightNeighbour->LeftNeighbour==RightChild)
                RightNeighbour->LeftNeighbour=this;
        else
                if (RightNeighbour->RightNeighbour==RightChild)
                        RightNeighbour->RightNeighbour=this;
                else
                {
                        RightNeighbour->BaseNeighbour=this;
                }
        pool->FreeNode(RightChild);
        RightChild=NULL;
}

void BTTNode::CreateChildren(BTTPool *pool)
{
        LeftChild=pool->AllocateNode(level-1, this);
        RightChild=pool->AllocateNode(level-1, this);
        if (LeftNeighbour)
        {
                LeftChild->BaseNeighbour=LeftNeighbour;
                if (LeftNeighbour->LeftNeighbour==this)
                {
                        LeftNeighbour->LeftNeighbour=LeftChild;
                }
                else
                        if (LeftNeighbour->RightNeighbour==this)
                        {
                                LeftNeighbour->RightNeighbour=LeftChild;
                        }
                        else
                        {
                                LeftNeighbour->BaseNeighbour=LeftChild;
                        }
        }
        if (RightNeighbour)
        {
                RightChild->BaseNeighbour=RightNeighbour;
                if (RightNeighbour->RightNeighbour==this)
                {
                        RightNeighbour->RightNeighbour=RightChild;
                }
                else
                        if (RightNeighbour->LeftNeighbour==this)
                        {
                                RightNeighbour->LeftNeighbour=RightChild;
                        }
                        else
                        {
                                RightNeighbour->BaseNeighbour=RightChild;
                        }
        }
        LeftChild->LeftNeighbour=RightChild;
        RightChild->RightNeighbour=LeftChild;
}

void BTTNode::SplitTwo(BTTPool *pool)
{
        BTTNode *t2;
        t2=BaseNeighbour;
        CreateChildren(pool);
        t2->CreateChildren(pool);
        LeftChild->RightNeighbour=t2->RightChild;
        RightChild->LeftNeighbour=t2->LeftChild;
        t2->LeftChild->RightNeighbour=RightChild;
        t2->RightChild->LeftNeighbour=LeftChild;
}

