#ifndef _BTTNODE_H 

#define _BTTNODE_H 1

#include "vector3d.h"
#include "triangleinfotree.h"
#include <SDL.h>

#define NOT_IN_QUEUE 9999999

class BTTPool;

class BTTNode
                        /** Binary Triangle Tree Node. Used by ROAM. */
{
        private:
        public:
                char level;
                /**< level of triangle, level 0 means smallest triangle */

                int QueuePos; /**< position in queue (Qs or Qm) */

                BTTNode *LeftNeighbour; /**< pointer to left neighbour */
                BTTNode *RightNeighbour; /**< pointer to right neighbour */
                BTTNode *BaseNeighbour; /**< pointer to base neighbour */
                BTTNode *LeftChild; /**< pointer to left child */
                BTTNode *RightChild; /**< pointer to right child */
                BTTNode *Parent; /**< pointer to parent */

                void CreateChildren(BTTPool *pool);
                /**< allocate two new bttnodes of smaller level */

                void SplitTwo(BTTPool *pool);
                /**< split two bttnodes - itself and base neighbour */

                void Merge(BTTPool *pool);
                /**< merge itself, i.e. destroy children, two merges (base
                 * neightbour!) are needed at once */ 
};

#endif
