#include "bttpool.h"
#include <iostream>

BTTPool::BTTPool(int _maxsize)
{
        int i;
        cout <<"new BTTPool\n";
        maxsize=_maxsize;
        Pool=new BTTNode * [maxsize];
        cout <<sizeof(BTTNode*)*maxsize<<" bytes allocated for pointers array\n";
        PoolSize=maxsize;
        for (i=0;i<maxsize;i++)
        {
                Pool[i]=new BTTNode();
        }
        cout <<sizeof(BTTNode)*maxsize<<" bytes allocated for BTTNode array\n";
}

BTTPool::~BTTPool()
{
        int i;
        cout <<"delete BTTPool\n";
        for (i=0;i<maxsize;i++)
        {
                if (Pool[i]==NULL)
                {
                        cout <<"Pool["<<i<<"]=NULL\n";
                        exit(-1);
                }
                delete Pool[i];
        }
        delete [] Pool;
}

BTTNode *BTTPool::AllocateNode(int _level, BTTNode *_parent)
{
        BTTNode *bttnode;
        PoolSize--;
        bttnode=Pool[PoolSize];
        bttnode->LeftChild=NULL;
        bttnode->RightChild=NULL;
        bttnode->LeftNeighbour=NULL;
        bttnode->RightNeighbour=NULL;
        bttnode->BaseNeighbour=NULL;
        bttnode->level=_level;
        bttnode->Parent=_parent;
        bttnode->QueuePos=NOT_IN_QUEUE;
        bttnode->QueuePos=NOT_IN_QUEUE;
        return bttnode;
}

void BTTPool::FreeNode(BTTNode *bttnode)
{
        Pool[PoolSize]=bttnode;
        PoolSize++;
}
