#ifndef _CAMERA_H

#define _CAMERA_H

#include "vector3d.h"
#include "matrix4.h"
#include "object3d.h"
#include "mobile.h"
#include <string>

class Camera
                        /** Camera in 3D space.*/
{
        private:
                Vector3D Eye; /**< where camera is located */
                Vector3D Point; /**< where camera is pointed */
                Vector3D Up; /**< vector pointed "up" from camera location */
                Matrix4 Matrix; /**< camera matrix */
        public:
                Camera();
                Camera (Vector3D e, Vector3D p, Vector3D u);
                Camera (Vector3D e, Vector3D p);
                ~Camera ();
                void SetGLCamera (); /**< sets GL_MODELVIEW matrix with camera transform */
                void CalcMatrix(); /**< calculates camera matrix from vectors */
                void SetEye(Vector3D e); /**< sets Eye vector */
                void SetPoint(Vector3D p); /**< sets Point vector */
                void SetUp(Vector3D u); /**< sets Up vector */
                Vector3D GetEye(); /**< returns Eye vector */
                string GetEyeString(); /**< returns string with Eye position */
};

#endif

