#include "face.h"

Face::Face()
{
}

Face::Face (Point3D ** points, int _v1, int _v2, int _v3)
{
        v1 = points[_v1];
        v2 = points[_v2];
        v3 = points[_v3];
}

Face::Face (Point3D *_v1, Point3D *_v2, Point3D *_v3)
{
        v1 =  _v1;
        v2 =  _v2;
        v3 =  _v3;
}

Face::Face (Point3D ** points, ifstream * f)
{
        int _v1, _v2, _v3;
        (*f)>>_v1;
        (*f)>>_v2;
        (*f)>>_v3;
        v1 = points[_v1];
        v2 = points[_v2];
        v3 = points[_v3];
}

void Face::Draw ()
{
        v1->Draw ();
        v2->Draw ();
        v3->Draw ();
}

void Face::CalcNormal ()
{
        Vector3D vec1, vec2;

        vec1=Vector3D(v1->GetPosition(),v2->GetPosition());
        vec2=Vector3D(v1->GetPosition(),v3->GetPosition());
        normal = vec1.CrossProduct(vec2);
        normal.Normalize ();
        v1->AddNormal (normal);
        v2->AddNormal (normal);
        v3->AddNormal (normal);
}

int Face::PointInsideXZ (Vector3D p)
{
        Vector3D vv1, vv2, vv3;
        vv1 = v1->GetPosition ();
        vv2 = v2->GetPosition ();
        vv3 = v3->GetPosition ();
        if ((p.PointSideXZ (&vv1, &vv2) <= 0)
                        &&
                        (p.PointSideXZ (&vv2, &vv3) <= 0) && (p.PointSideXZ (&vv3, &vv1) <= 0))
                return 1;
        else
                return 0;
}
