#ifndef _FACE_H

#define _FACE_H

#include "vector3d.h"
#include "point3d.h"
#include <fstream>

class Face
                        /** Triangle in 3D space, defined by 3 vertices. */
{
        protected:
                Point3D *v1; /**< vertex 1 */
                Point3D *v2; /**< vertex 2 */
                Point3D *v3; /**< vertex 3 */
                Vector3D normal; /**< normal to face */
        public:
                Face();
                Face (Point3D ** points, int _v1, int _v2, int _v3);
                Face (Point3D ** points, ifstream * f);
                Face (Point3D *_v1, Point3D *_v2, Point3D *_v3);

                void Draw (); /**< draw face using OpenGL */

                void CalcNormal (); /**< calculate normal and add it to vertices */

                int PointInsideXZ (Vector3D p); /**< Check if coordinates (x,z) of point p
                					 are inside triangle */
};

#endif
