#include "landscape.h"
#include "gamemanager.h"
#include <iostream>
#include <sstream>
#include <GL/gl.h>
#include "common.h"
#include "copter.h"

#define speed 50.0

#define ViewDistance 25000.0

int main()
{
        GameManager *gm;
        ostringstream oss;
        int done;
        Vector3D position;
        double alpha;

        done=0;
        position=Vector3D(0,1000,0);
        alpha=0.0;

        gm=new GameManager(InitialScreenWidth,InitialScreenHeight,InitialScreenBPP);

        gm->LoadLandscape("maps/default.land",ViewDistance,40000,MainPatchLevel);

        gm->InitCopter("3D/copter.metamesh");

        while (!done)
        {
                gm->StartFrame();

                gm->SwitchCameraView(); //keys are being checked
                gm->FollowWithCamera(); //camera view is set
                gm->SetGLCamera();
                gm->SetLight();

                //gm->Set3DMode(45,10.0,ViewDistance);
                gm->Set3DMode(45,3.0,ViewDistance);

                gm->DrawLandscape(0.05);


                glEnable(GL_TEXTURE_2D);
                glEnable (GL_DEPTH_TEST);
                glEnable (GL_CULL_FACE);
                glEnable(GL_LIGHTING);
                glEnable(GL_LIGHT0);

                gm->DrawCopter();

                glDisable(GL_TEXTURE_2D);
                glDisable (GL_DEPTH_TEST);
                glDisable (GL_CULL_FACE);
                glDisable(GL_LIGHTING);
                glDisable(GL_LIGHT0);

                gm->Set2DMode();

                gm->DrawInfo();

                gm->UpdateFpsCounter();

                gm->KeysStep();

                gm->CopterStep();

                gm->EndFrame();
                done=gm->Done();
        }

        delete gm;

        SDL_Quit();

        return 0;
}
