#include "fpscounter.h"
#include <SDL.h>
#include <GL/gl.h>
#include <iostream>
#include <sstream>

FpsCounter::FpsCounter(Text2D *_text)
{
        cout <<"new FpsCounter\n";
        text=_text;
        x=0.9;
        y=0.97;
        Reset();
}

FpsCounter::~FpsCounter()
{
}

void FpsCounter::Reset()
{
        t0=SDL_GetTicks();
        frames=0;
        fps=0;
}

void FpsCounter::AddFrame()
{
        int t;
        t=SDL_GetTicks();
        frames++;
        if ((t-t0)>=1000)
        {
                t0=t;
                fps=frames;
                frames=0;
        }
}

void FpsCounter::Display()
{
        ostringstream s;
        if (fps>0)
        {
                s.str("");
                s<<"fps: "<<fps;
                text->Print(x,y,s.str());
        }
}

