#ifndef _FPS_COUNTER_H

#define _FPS_COUNTER_H 1

#include "text2d.h"

class FpsCounter
                        /** Frames per second counter */
{
        private:
                int t0; /**< time in last frame */
                int frames; /**< frames since beginning of second */
                Text2D *text; /**< pointer to Text2D (i.e. font) */
                int fps; /**< calculated frames per second */
                double x,y; /**< position of counter on screen */
        public:
                FpsCounter(Text2D *_text);
                ~FpsCounter();
                void Reset(); /**< starts counting */
                void AddFrame(); /**< increase frames counter */
                void Display(); /**< draw fps on screen */
};

#endif
