#include "frustum.h"
#include <iostream>

Frustum::Frustum()
{
        cout << "new Frustum\n";
}

void Frustum::Calc()
{
        Matrix4 projection, modelview, clip;
        double a[4];

        projection.glGetProjectionMatrix();
        modelview.glGetModelviewMatrix();
        clip=projection*modelview;

        clip.SubColumns(3,0,a);
        planes[0]=Plane(a); // RIGHT

        clip.AddColumns(3,0,a);
        planes[1]=Plane(a); // LEFT

        clip.AddColumns(3,1,a);
        planes[2]=Plane(a); // BOTTOM

        clip.SubColumns(3,1,a);
        planes[3]=Plane(a); // TOP

        clip.SubColumns(3,2,a);
        planes[4]=Plane(a); // FAR

        clip.AddColumns(3,2,a);
        planes[5]=Plane(a); // NEAR
}

int Frustum::PointInside(Vector3D *p)
{
        int i;
        for (i=0;i<6;i++)
                if (!planes[i].PointSide(p))
                        return 0;
        return 1;
}

int Frustum::BoxInside(Box *box)
{
        int i,j;
        int inside;
        Vector3D *v;
        v=box->GetVertices();
        for (i=0;i<6;i++)
        {
                inside=0;
                for (j=0;j<8;j++)
                        if (planes[i].PointSide(&v[j]))
                                inside++;
                if (inside==0)
                        return 0;
        }
        return 1;
}

void Frustum::Print()
{
        int i;
        cout <<"Frustum:\n";
        for (i=0;i<6;i++)
                planes[i].Print();
        cout <<"\n";
}
