#ifndef _FRUSTUM_H

#define _FRUSTUM_H 1

#include "plane.h"
#include "matrix4.h"
#include "box.h"

class Frustum
                        /** Frustum of view. */
{
        private:
                Plane planes[6]; /**< frustum is defined by 6 planes */
        public:
                Frustum();

                void Calc(); /**< calculates planes by analizing OpenGL view
                information */

                int PointInside(Vector3D *p);
                /**< returns 1 if point p is inside frustum */

                int BoxInside(Box *box);
                /**< returns 1 if at least part of box is inside frustum */

                void Print();
                /**< prints planes */
};

#endif
