#ifndef _IMAGE_H

#define _IMAGE_H 1

using namespace std;

#include <SDL.h>
#include <string>
#include <GL/gl.h>

class Image
                        /**< 2D image. */
{
        private:
                SDL_Surface *surface; /**< pointer to surface which contain image */
                int pitch; /**< width of line in bytes */
                Uint8 *pixels; /**< pointer to pixel array */
                int bpp; /**< bits per pixel of image */
        public:
                Image(string filename);
                ~Image();

                Uint8 GetPixel(int x, int y); /**< returns 1 byte value of
                pixel from position (x,y) */

                void GetRGBPixel(int x, int y, Uint8 *r, Uint8 *g, Uint8 *b);
                /**< returns 3 bytes value of pixel from position (x,y) */

                int GetWidth(); /**< returns width of image */

                int GetHeight(); /**< returns height of image */

                GLuint GenerateTexture(); /**< generates OpenGL texture from
                image and returns its identifier */
};

#endif
