#include "indicestree.h"
#include <cmath>

IndicesTree::IndicesTree(int maxlevel, int _NumberOfPoints, int leftx, int leftz, int rightx, int rightz, int centerx, int centerz)
{
        node=1;
        NumberOfPoints=_NumberOfPoints;
        size=(int)pow(2.0,(double)maxlevel);
        Indices=new int * [size];
        SetPositions(leftx,leftz,rightx,rightz,centerx,centerz);
}

IndicesTree::~IndicesTree()
{
        int i;
        for (i=0;i<size;i++)
                delete Indices[i];
        delete [] Indices;
}

void IndicesTree::SetPositions(int leftx, int leftz, int rightx, int rightz, int centerx, int centerz)
{
        Indices[node-1]=new int [3];
        Indices[node-1][0]=leftx+leftz*(NumberOfPoints);
        Indices[node-1][1]=rightx+rightz*(NumberOfPoints);
        Indices[node-1][2]=centerx+centerz*(NumberOfPoints);
        if (node<size/2)
        {
                node=node<<1;
                SetPositions(centerx,centerz,leftx,leftz,(leftx+rightx)/2,(leftz+rightz)/2);
                node++;
                SetPositions(rightx,rightz,centerx,centerz,(leftx+rightx)/2,(leftz+rightz)/2);
                node=node>>1;
        }
}

int IndicesTree::GetIndex(int p)
{
        return Indices[p][0];
}

int **IndicesTree::Get()
{
        return Indices;
}
