#ifndef _INDICES_TREE_H

#define _INDICES_TREE_H 1

#include <GL/gl.h>

class IndicesTree
                        /** Tree with indices of vertices for every patch. */
{
        private:
                int size; /**< how many indices are stored in tree */
                int **Indices; /**< every node is 3 integers */
                int node; /**< current node in tree */
                int NumberOfPoints; /**< size of patch in points */
                void SetPositions(int leftx, int leftz, int rightx, int rightz, int centerx, int centerz);

        public:
                IndicesTree(int maxlevel, int _NumberOfPoints, int leftx, int leftz, int rightx, int rightz, int centerx, int centerz);
                ~IndicesTree();

                int GetIndex(int p); /**< returns first index of node p */
                int **Get(); /**< returns all indices */
};

#endif


