#include "landscapetexture.h"
#include <SDL.h>
#include <iostream>
#include <string>
#include "image.h"

LandscapeTexture::LandscapeTexture(ifstream *f, string name)
{
        (*f)>>Scale;

        occurrence=new Occurrence(f);

        image=new Image(name);
}

LandscapeTexture::~LandscapeTexture()
{
        delete image;
}


double LandscapeTexture::GetPixel(double x, double z, double h, double a, Uint8 *r, Uint8 *g, Uint8 *b)
{
        int xi,zi;

        xi=((int)(Scale*x))%image->GetWidth();
        zi=((int)(Scale*z))%image->GetHeight();

        image->GetRGBPixel(xi,zi,r,g,b);

        return occurrence->CalcFinalWeight(x,z,h,a);

}

