#ifndef _LANDSCAPE_TEXTURE

#define _LANDSCAPE_TEXTURE 1

#include <fstream>
#include <string>
#include "image.h"
#include "occurrence.h"

class LandscapeTexture
                        /** One of textures which is placed on landscape. This is "source" texture.
                         * All source textures are mixed to final one */
{
        private:
                double Scale; /**< zoom of texture on landscape*/
                Image *image; /**< texture image itself */
                Occurrence *occurrence; /**< where texture should be placed */
        public:
                LandscapeTexture(ifstream *f, string name);
                ~LandscapeTexture();
                double GetPixel(double x, double z, double h, double a, Uint8 *r, Uint8 *g, Uint8 *b);
                /**< returns alpha and colors (r,g,b) from this texture,
                 * assuming input data: x,z,h,a */
};

#endif
