#ifndef _MERGEABLE_DIAMOND_H

#define _MERGEABLE_DIAMOND_H 1

#include "vector3d.h"
#include "bttnode.h"

class MergeableDiamond
                        /** Diamond - two splitted triangles on landscape. */
{
        private:
        public:
                int LandscapeUpdateArray_nr; /**< number of update array */
                int LandscapeUpdateArray_pos; /**< position in update array */
                float priority; /**< ROAM priority */
                BTTNode *FirstBTTNode; /**< pointer to bttnode of first triangle */
                BTTNode *SecondBTTNode; /**< pointer to bttnode of second triangle */
                TriangleInfoTree *First_it; /**< info tree of first triangle */
                TriangleInfoTree *Second_it; /**< info tree of second triangle */
                int First_it_node; /**< position of first triangle in info tree */
                int Second_it_node; /**< position of second triangle in info tree */

                MergeableDiamond();
                ~MergeableDiamond();

                void CalcPriority(Vector3D *CameraPosition, double maxx, double maxz, double ViewDistance);
};

#endif
