#ifndef _MESHSET_H

#define _MESHSET_H 1

#include "mesh.h"
#include <string>

class MetaMesh
                        /** Group of meshes. */
{
        private:
                Mesh **meshes; /**< array of meshes */
                int nmeshes; /**< number of meshes */
                double BoundingSphereRadius; /**< radius of bounding sphere of
                				  group of meshes */
        public:
                MetaMesh();
                MetaMesh (string filename);
                ~MetaMesh ();

                void CalcNormals (); /**< calculates normal for every point in
                			  every mesh */
                void GenerateLists(); /**< generates OpenGL list for every mesh */

                int GetNMeshes(); /**< returns number of meshes */
                Mesh *GetMesh(int i); /**< returns mesh number i */
                Mesh *GetMesh(string n); /**< returns mesh with name n */
                double GetBoundingSphereRadius(); /**< returns radius of bounding sphere */

                void FindBoundingSphereRadius(); /**< calculates radious of bounding sphere */

};

#endif
