#ifndef _METAOBJECT3D_H

#define _METAOBJECT3D_H 1

#include "object3d.h"
#include "metamesh.h"
#include "text2d.h"
#include "image.h"
#include <map>

class MetaObject3D
                        /** Group of objects */
{
        protected:
                map <string,Object3D*> objects; /**< every object has its name,
                				     two objects in different
                				     MetaObjects can have same
                				     names */
                Matrix4 matrix; /**< transformation matrix for whole group of
                		     objects, very object has its own matrix
                		     too */
        public:
                MetaObject3D(MetaMesh *meshes);
                virtual ~MetaObject3D();

                void SetMatrix(Matrix4 m); /**< sets matrix of group of object */
                void SetObjectMatrix(string name,Matrix4 m); /**< sets private
                						  matrix of one
                						  object */
                void Draw(); /**< draw groups of objects */
                void SetTexture(string name, GLuint t); /**< set texture of one object */
                void SetTextures(string filename); /**< set textures for groups
                					of objects, texture
                					names are taken from
                					file */
};

#endif
