#include "mobile.h"
#include <cmath>

Mobile::Mobile (MetaMesh *m, Vector3D _position, Landscape *l):MetaObject3D(m)
{
        Position=_position;
        Yaw=0;
        Roll=0;
        Pitch=0;
        SetMatrices();
        landscape=l;
}

Mobile::~Mobile()
{
}

void Mobile::SetMatrices()
{
        Matrix4 r1,r2,r3,t;
        r1.CreateRotateYMatrix(Yaw);
        r2.CreateRotateZMatrix(Roll);
        r3.CreateRotateXMatrix(Pitch);
        Orientation=r1*r3*r2;
        t.CreateTranslateMatrix(Position);
        matrix=t*Orientation;
}

Vector3D Mobile::GetPosition()
{
        return Position;
}

Matrix4 Mobile::GetOrientation()
{
        return Orientation;
}

void Mobile::CheckCrash()
{
        Vector3D ContactPoint;
        Vector3D v;
        v=Vector3D(0,0,0);
        map<string,Object3D*>::const_iterator i;
        Height=landscape->GetHeight(Position.x,Position.z);
        ContactPoint=Vector3D(Position.x,Height,Position.z);
        Height=Position.y-Height;
        ContactPoint-=Position;
        for (i=objects.begin();i!=objects.end();i++)
        {
                if (i->second->CheckCrash(ContactPoint))
                {
                        Crash=1;
                        return;
                }
        }
        Crash=0;
}

int Mobile::Crashed()
{
        return Crash;
}
