#ifndef _MOBILE_H

#define _MOBILE_H 1

#include "metaobject3d.h"
#include "metamesh.h"
#include "landscape.h"

#include <SDL.h>

class Mobile:public MetaObject3D
{
        protected:
                Vector3D Position; /**< position of mobile */
                double Yaw; /**< yaw angle */
                double Roll; /**< roll angle */
                double Pitch; /**< pitch angle */
                Vector3D Velocity; /**< linear velocity */
                Vector3D Acceleration; /**< linear acceleration */
                Matrix4 Orientation; /**< rotation matrix, calculated from angles */
                Landscape *landscape; /**< pointer to landscape, for crash testing */
                int Crash; /**< already crashed? */
                double Height; /**< relative height over landscape */
        public:
                Mobile (MetaMesh *m, Vector3D _position, Landscape *l);
                ~Mobile();
                void SetMatrices(); /**< sets orientation matrix and metaobject matrix */
                Vector3D GetPosition(); /**< returns position of mobile */
                Matrix4 GetOrientation(); /**< returns orientation matrix of mobile */
                void CheckCrash(); /**< currently checks only if bounding
                			spheres touch ground */
                int Crashed(); /**< returns 1 if mobile is crashed */
};

#endif
