#include "object3d.h"
#include <GL/gl.h>
#include <iostream>

Object3D::Object3D (Mesh * _mesh)
{
        mesh = _mesh;
        if (mesh==NULL)
        {
                cout <<"Object3D::Object3D mesh==NULL\n";
                exit(-1);
        }
        matrix.LoadIdentity();
        SetMatrixWithoutLoc(matrix);
}

Object3D::~Object3D ()
{
}

void Object3D::Draw ()
{
        glMatrixMode(GL_MODELVIEW);
        glBindTexture(GL_TEXTURE_2D,texture);
        glPushMatrix ();
        matrix.glMultMatrix();
        mesh->Draw ();
        glPopMatrix ();
}

void Object3D::DrawNormals ()
{
        glPushMatrix ();
        matrix.glMultMatrix();
        mesh->DrawNormals ();
        glPopMatrix ();
}

Vector3D Object3D::RandomPosition ()
{
        Vector3D v;
        v = mesh->RandomPoint ()->GetPosition ();
        v = matrix * v;
        return v;
}

Mesh *Object3D::GetMesh ()
{
        return mesh;
}

void Object3D::SetMatrixWithoutLoc (Matrix4 m)
{
        Matrix4 mt;
        mt.CreateTranslateMatrix(mesh->GetLoc());
        matrix=mt*m;
}

void Object3D::SetTexture(GLuint t)
{
        texture=t;
}

int Object3D::CheckCrash(Vector3D ContactPoint)
{
        return mesh->CheckCrash(ContactPoint);
}
