#ifndef _OBJECT3D_H

#define _OBJECT3D_H 1

#include "mesh.h"

class Object3D
                        /** Object containing one mesh in 3D space. */
{
        private:
                Matrix4 matrix; /**< object matrix - traslation, rotation,
                		     scale, etc... */
                Mesh *mesh; /**< pointer to mesh */
                GLuint texture; /**< identifier of OpenGL texture */
        public:
                Object3D (Mesh * _mesh); /**< only way to make object is to
                			      pass pointer to mesh which
                			      already exist */
                ~Object3D ();

                void SetTexture(GLuint t); /**< sets OpenGL texture identifier */

                void SetMatrixWithoutLoc (Matrix4 m); /**< sets current matrix
                					   to translation
                					   matrix multiplied by
                					   m */

                void Draw ();		/**< draw mesh with matrix
                			     transformation and texture */

                void DrawNormals ();	/**< draw normals of mesh */

                Mesh *GetMesh ();	/**< returns mesh of object */

                Vector3D RandomPosition (); /**< returns position of random
                				 point on object mesh */


                int CheckCrash(Vector3D ContactPoint); /**< returns 1 if
                					    ContactPoint is
                					    inside mesh */
};

#endif
