#include "occurrence.h"

Occurrence::Occurrence(ifstream *f)
{
        (*f)>>HeightMin;
        (*f)>>HeightMax;
        (*f)>>HeightRelease;

        (*f)>>AngleMin;
        (*f)>>AngleMax;
        (*f)>>AngleRelease;

        (*f)>>XMin;
        (*f)>>XMax;
        (*f)>>XRelease;

        (*f)>>ZMin;
        (*f)>>ZMax;
        (*f)>>ZRelease;
        if ((XMin==0.0) && (XMax==1.0) && (ZMin==0.0) && (ZMax==0.0))
                FullData=0;
        else
                FullData=1;
}

double Occurrence::CalcWeight(double v, double vmin, double vmax, double vrelease)
{
        double weight;
        double d;
        if ((v>=vmin) && (v<=vmax))
                return 1.0;
        if (vrelease==0.0)
                return 0.0;

        if (v<vmin)
                d=vmin-v;
        else
                d=v-vmax;

        weight=1.0-d/vrelease;
        if (weight<0.0)
                weight=0.0;

        return weight;
}

double Occurrence::CalcFinalWeight(double x, double z, double h, double a)
{
        double xweight,zweight,hweight,aweight;
        hweight=CalcWeight(h,HeightMin,HeightMax,HeightRelease);
        aweight=CalcWeight(a,AngleMin,AngleMax,AngleRelease);

        if (FullData)
        {
                xweight=CalcWeight(x,XMin,XMax,XRelease);
                zweight=CalcWeight(z,ZMin,ZMax,ZRelease);
                return xweight*zweight*hweight*aweight;
        }
        else
                return hweight*aweight;
};

