#ifndef _PLANE_H

#define _PLANE_H 1

#include "vector3d.h"
#include "box.h"

class Plane
                        /* Plane in 3D space. Ax+By+Cz+D=0 */
{
        private:
                double A;
                double B;
                double C;
                double D;
        public:
                Plane();
                Plane(double _A,double _B,double _C,double _D);
                Plane(double *a);

                int PointSide(Vector3D *p); /**< returns on which side of plane
                is given point p */

                double Distance(Vector3D p); /**< returns distance of point p
                from plane */

                void Print();
};

#endif
