#include "point3d.h"
#include <GL/gl.h>

Point3D::Point3D (const Vector3D &pos, float _u, float _v)
{
        Position = pos;
        u = _u;
        v = _v;
}

Point3D::Point3D (const Vector3D &pos)
{
        Position = pos;
}

Point3D::Point3D (const Point3D &p)
{
        Position=p.Position;
        Normal=p.Normal;
        u=p.u;
        v=p.v;
}

void Point3D::SetPosition (Vector3D vec)
{
        Position = vec;
}

void Point3D::SetNormal (Vector3D vec)
{
        Normal = vec;
}

void Point3D::Draw ()
{
        Normal.glNormal ();
        glTexCoord2f(u,v);
        Position.glVertex ();
}

void Point3D::DrawNormal ()
{
        Vector3D vec;
        Position.glVertex ();
        vec=Position+Normal;
        vec.glVertex ();
}

void Point3D::AddNormal (Vector3D n)
{
        Normal += n;
}

void Point3D::CalcNormal ()
{
        Normal.Normalize ();
}

Vector3D Point3D::GetPosition ()
{
        return Position;
}

Vector3D Point3D::GetNormal ()
{
        return Normal;
}

void Point3D::Print()
{
        Position.Print();
        Normal.Print();
        cout <<"u="<<u<<" v="<<v<<"\n";
}

void Point3D::SetTexCoord(float _u, float _v)
{
        u=_u;
        v=_v;
}
