#include <SDL.h>
#include <GL/gl.h>
#include "text2d.h"
#include <iostream>
#include <string.h>
#include "image.h"

Text2D::Text2D()
{
}

Text2D::Text2D(string filename, double size)
{
        Image *image;
        int i;
        int x,y;

        image=new Image(filename);
        FontTexture=image->GenerateTexture();
        delete image;

        lists=glGenLists(256);
        if (lists==0)
        {
                cout <<"oops, can't GenList\n";
                exit(-1);
        }
        cout <<"FontTexture: "<<FontTexture<<"\n";
        cout <<"256 lists generated for text output, first list is "<<lists<<"\n";
        glBindTexture(GL_TEXTURE_2D,FontTexture);

        for (i=0;i<256;i++)
        {
                x=(i%16);
                y=(i/16);
                glNewList(lists+i,GL_COMPILE);
                glBegin(GL_QUADS);

                glTexCoord2f((x)/16.0,(y+1)/16.0);
                glVertex2f(0,0);

                glTexCoord2f((x+1)/16.0,(y+1)/16.0);
                glVertex2f(size,0);

                glTexCoord2f((x+1)/16.0,(y)/16.0);
                glVertex2f(size,size);

                glTexCoord2f((x)/16.0,(y)/16.0);
                glVertex2f(0,size);

                glEnd();
                glTranslatef(size*2/4,0,0);
                glEndList();
        }

        cout <<"font created\n";
}

void Text2D::SwitchToText()
{
        glEnable(GL_TEXTURE_2D);
        glEnable(GL_BLEND);
        glBlendFunc(GL_SRC_ALPHA,GL_ONE);
        glColor3f(1.0,1.0,1.0);
        glMatrixMode(GL_PROJECTION);
        glPushMatrix();
        glLoadIdentity();
        glOrtho(-1.0,1.0,-1.0,1.0,0.0,1.0);
        glMatrixMode(GL_MODELVIEW);
        glPushMatrix();
        glBindTexture(GL_TEXTURE_2D,FontTexture);
}

void Text2D::BackFromText()
{
        glMatrixMode(GL_PROJECTION);
        glPopMatrix();
        glMatrixMode(GL_MODELVIEW);
        glPopMatrix();
        glDisable(GL_TEXTURE_2D);
        glDisable(GL_BLEND);
}

void Text2D::Print(string s)
{
        unsigned int i;
        const char *str;
        glEnable(GL_TEXTURE_2D);
        glEnable(GL_BLEND);
        glBlendFunc(GL_SRC_ALPHA,GL_ONE);
        glBindTexture(GL_TEXTURE_2D,FontTexture);
        str=s.c_str();
        for (i=0;i<strlen(str);i++)
                glCallList(lists+str[i]-32);
        glDisable(GL_TEXTURE_2D);
        glDisable(GL_BLEND);
}

void Text2D::Print(float x, float y, string s)
{
        glPushMatrix();
        glMatrixMode(GL_MODELVIEW);
        glLoadIdentity();
        glTranslatef(x,y,0);
        Print(s);
        glPopMatrix();
}
