#ifndef _TRIANGLE_INFO_TREE_H

#define _TRIANGLE_INFO_TREE_H 1

#include "vector3d.h"
#include <SDL.h>
#include "heightmap.h"
#include <GL/gl.h>
#include "indicestree.h"
#include "vertexstruct.h"

class TriangleInfoTree
{
        private:
        public:
                int Visible; /**< is any triangle from this tree visible? */
                double px; /**< x position of center of triangle */
                double py; /**< y position of center of triangle */
                double pz; /**< z position of center of triangle */
                HeightMap *hm; /**< pointer to height map */
                float *error; /**< tree of triangle errors */
                int size; /**< size of tree */
                int node; /**< current node of tree */
                IndicesTree *indicestree; /**< tree of indices of points in patch */

                TriangleInfoTree(double leftx, double leftz, double rightx, double rightz, double centerx, double centerz, int maxlevel, HeightMap *_hm,VertexStruct *_Vertices, double _x1, double _z1, IndicesTree *_indicestree);
                ~TriangleInfoTree();

                double Calc(double leftx, double leftz, double rightx, double rightz, double centerx, double centerz);

                void SetPositions(int leftx,int leftz, int rightx, int rightz, int centerx, int centerz);

                int GetIndex(int p);
};

#endif
